
// LaneDetectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LaneDetection.h"
#include "LaneDetectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLaneDetectionDlg dialog

CLaneDetectionDlg::CLaneDetectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLaneDetectionDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	_lane = NULL;
	_cam = NULL;
}

void CLaneDetectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLaneDetectionDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPEN, &CLaneDetectionDlg::OnBnClickedOpen)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_STEP, &CLaneDetectionDlg::OnBnClickedBtStep)
END_MESSAGE_MAP()


// CLaneDetectionDlg message handlers

BOOL CLaneDetectionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	_lane = new CLaneDetect();

	_cam = new CCamOpenCV("Lane4.mp4");

	//SetTimer(1000, 500, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLaneDetectionDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLaneDetectionDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CLaneDetectionDlg::OnBnClickedOpen()
{
	CString str = _T("MP4 File(*.mp4)|*.mp4|Avi File(*.avi)|*.avi|");

	CFileDialog dlg (TRUE, "*.mp4", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, str, this);

	if (dlg.DoModal() == IDOK){
		if(_cam) delete _cam;
		_cam = new CCamOpenCV(dlg.GetPathName());

		SetTimer(1000, 30, 0);
	}
}

void CLaneDetectionDlg::DoLaneDetect ()
{
	assert (_cam);

	IplImage* src = _cam->CaptureImage();	
	if (src) {
		// ̹  lane ã  Ѵ.
		CvRect roi = cvRect (0, 100, 640, 330);

		cvSetImageROI (src, roi);

		IplImage* src_roi = cvCreateImage( cvSize(roi.width, roi.height), src->depth, src->nChannels);
		
		cvCopy (src, src_roi);

		cvResetImageROI (src);
		//------------------------------------------------

		IplImage* dst = cvCreateImage( cvGetSize(src_roi), IPL_DEPTH_8U, 3);

		cvCopy(src_roi, dst, 0);

		_lane->LaneDetect(src_roi, dst);

		cvReleaseImage(&src_roi);
		cvReleaseImage(&dst);
	}
}

void CLaneDetectionDlg::OnTimer(UINT_PTR nIDEvent)
{
	DoLaneDetect ();

	CDialog::OnTimer(nIDEvent);
}

void CLaneDetectionDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if(_cam) delete _cam;
	if(_lane) delete _lane;
}

void CLaneDetectionDlg::OnBnClickedBtStep()
{
	KillTimer(1000);

	DoLaneDetect ();
}
