#pragma once

#include <vector>
#include <math.h>

using namespace std;


struct sPoint {
	int x, y;

	sPoint() : x(0), y(0) { }
	sPoint(int x_, int y_) : x(x_), y(y_) { }
};

struct sLine {
	int sx, sy;
	int ex, ey;
	int dx, dy;
	double len;


	sLine() : sx(0), sy(0), ex(0), ey(0), dx(0), dy(0), len(0.) { }
	sLine(int sx_, int sy_, int ex_, int ey_) 
		: sx(sx_), sy(sy_), ex(ex_), ey(ey_) 
	{
		dx = ex - sx;
		dy = ey - sy;
		len = sqrt((double)(dx*dx + dy*dy));
	}
};

extern double compute_distance (const sLine &line, const sPoint &x);
extern double ransac_vanishing_point(vector<sLine> &data, sPoint &model, double distance_threshold);
